



############   probleme THN 
## 
##   thn-fevrier2023.py 
##                      origine : test10.py         
##   
##   fd, 04, 05, 14, 15, 17 juin 2021, 16, 17, 19 fevrier 2023, 18 mars 2024  
##   
############################################################################

import numpy as np
import scipy as sp
from scipy.special import ellipk ## , ellipkinc
from thn_bibliotheque import  * 

import matplotlib.pyplot as plt 
from pylab import savefig, title
from math import sin, cos, acos, asin, atan , pi, sqrt, exp, atan , tan, asin, log, floor, tan, tanh, atanh 
import matplotlib.animation as animation

from matplotlib.font_manager import FontProperties
from mpl_toolkits.axes_grid1 import host_subplot  
    
#####################################################################################################################
#####################################################################################################################
#####################################################################################################################
 
print ('===============================================================================================')
print ('===============================================================================================')
print ('thn-fevrier2023.py                                     Francois Dubois, juin 2021, fevrier 2023')
print ('===============================================================================================')
print ('resolution d un probleme simplfie et couple de Thermo-Hydrauliqte Neutronique') 
print ("comparaison d'une approche numerique et de solutions analytiques")
print ('   qui utilisent une fonction elliptique complete du premier ordre')
print ('le modele numerique et la resolution analytique sont decrits en detail dans l article')
print ("     d'Olivier Lafitte et de l'auteur")
print ('    "Analytic solutions and numerical method for a coupled thermo-neutronic problem"')
print ('    https://arxiv.org/abs/2205.05945  et https://hal.science/hal-03663985')
print ('on se donne une fonction u -> Sigma(u) definie sur [0,1] a partir de trois valeurs')
print ('    Sigma(0) = v00, Sigma(1/2) = v12,  Sigma(1) = v11')
print ('on cherche deux fonctions phi et u definies sur l intervalle [0,1]')
print ('et un nombre lambda > 0 appele zlambda dans le programme  et strictement positif de sorte que')
print ('   − d2phi / dx**2 + phi(x) = lambda Sigma(u(x)) phi(x)     pour 0 < x < 1')
print ('    dh / dx = phi(x),    pour 0 < x < 1')
print ('    u(0) = 0, u(1) = 1, phi(0) = phi(1) = 0   et  phi(x) > 0 pour  0 < x < 1.') 
print ('On doit construire la fonction  Sigma(u) par interpolation ')
print ('Ce logiciel ne traite que quelques cas particuliers parametres par deux nombres entiers')
print ('  flag         : entre 0 et 12      choix des trois valeurs v00, v12, v11 ')
print ("  interpol_ini : entre 0 et 5       type d'interpolation") 
print ('===============================================================================================')
print ('attention ! pour des raisons de fond, les couplages') 
print ('    flag = 0   et  interpol = 2')
print ('          cas test Sigma(u) constant et fonction Sigma est vraiment polynomiale de degre 2')
print ('    flag = 1   et  interpol = 2')
print ('          cas test Sigma(u) lineaire et fonction Sigma est vraiment polynomiale de degre 2')
print ('    flag = 2   et  interpol = 2')
print ('          cas test Sigma(u) lineaire donne en trois points, cas fd difficile')
print ('    flag = 2   et  interpol = 4')
print ('          cas test Sigma(u) lineaire donne en trois points, cas fd difficile')
print ('          la fonction Sigma est quadratique mais on la modifie pour la rendre affine')
print ('    flag = 10  et  interpol = 4')
print ('          cas test Sigma(u) donne en trois points, cas mechant en vallon')
print ('          la fonction Sigma est quadratique mais on la modifie pour la rendre affine')
print ("se plantent ! Et c'est tout a fait coherent... ")
print ('===============================================================================================')

flag = 10
interpol_ini = 3  

print ("drapeau de choix du type d interpolation                   flag         =", flag)
print ("choix initial pour l interpolation de la fonction Sigma    interpol_ini =", interpol_ini)
print ('===============================================================================================')

jbavard = 2
print ("choix du niveau de bavardage    0 <= jlambda <= 2               jbavard = ", jbavard)

if jbavard == 1 : print ('jbavard =  1     sortie a l ecran des resultats globaux ')
if jbavard == 2 : print ('jbavard =  2     sortie de plus de resultats, de graphiques et de fichiers de donnees')
if jbavard >= 3 : print ('jbavard >= 3     a eviter, pour la mise au point !')

print ('===============================================================================================')
if jbavard >= 2 : 
        print ('quelques precisions sur les parametres flag et interpol')

        print ('flag = 0         cas test Sigma(u) constant')
        print ('flag = 1         cas test Sigma(u) lineaire')
        print ('flag = 2         cas test Sigma(u) lineaire donne en trois points, cas fd difficile')
        print ("flag = 3         cas test Sigma(u) lineaire donne en trois points, cas Oliver facile")
        print ('flag = 4         cas test Sigma(u) lineaire donne en trois points, cas fd moins difficile')
        print ('flag = 5         cas test Sigma(u) donne en trois points, variante convexe du cas d Olivier')
        print ('flag = 6         cas test Sigma(u) donne en trois points, poles complexes ?')
        print ('flag = 7         cas test Sigma(u) donne en trois points, deux racines reelles negatives')
        print ('flag = 8         cas test Sigma(u) donne en trois points, deux racines reelles superieures a un')
        print ('flag = 9         cas test Sigma(u) concave presque lineaire')
        print ('flag = 10        cas test Sigma(u) donne en trois points, cas mechant en vallon')
        print ('flag = 11        cas test Sigma(u) donne en trois points, cas en chapeau chinois')
        print ('flag = 12        cas test Sigma(u) donne en trois points, raccord P2-P3')      
        print ('interpol = 0     on se contente de la valeur moyenne des donnees de Sigma') 
        print ('                 le calcul de coin de table suffit') 
        print ('                 on fait tourner le job avec une interpolation P1 par morceaux')
        print ('interpol = 1     on suppose fonction Sigma donnee par une interpolation affine') 
        print ('                 le seul test affine suppose flag=1')
        print ('                 sinon on force l interpolation affine en ignorant v12') 
        print ('interpol = 2     la fonction Sigma est une interpolation vraiment polynomiale de degre 2')
        print ('attention : les cas flag=0, 1 et 2 se plantent si interpol=2 et c est tout a fait normal !')
        print ('interpol = 3     la fonction Sigma est affine par morceaux')
        print ('interpol = 4     la fonction Sigma est quadratique mais on la modifie')
        print ('                 avec une approche variationnelle pour la rendre affine')
        print ('attention : les cas flag=2 et 10 se plantent si interpol=4 et c est tout a fait normal !')
        print ('interpol = 5     la fonction Sigma est affine par morceaux mais on la modifie')
        print ('                 avec une approche variationnelle pour la rendre affine')
        print ('===============================================================================================')


jbavard = 1
print ("pretraitement avec le sous-programme 'affecte_flag'") 

v00,v12,v11,zlambda,llmin,llmax = affecte_flag (jbavard,flag,interpol_ini) 
print ("estimation de zlambda a l issue du pretraitement                zlambda =", zlambda)

interpol = interpol_ini
if (interpol_ini==0) : interpol = 3
if (interpol_ini==1) : interpol = 3
if (interpol_ini==4) : interpol = 3
if (interpol_ini==5) : interpol = 3

moyenne = .25*v00 + .5*v12 + .25*v11 ; lambda_coindetable = (1.+pi*pi)/moyenne
if (jbavard>=2) :
    print ("v00") ; print (v00) ; print ("v12") ; print (v12) ; print ("v11") ; print (v11)
    
print ("valeur moyenne des donnees de la fonction Sigma modifiee        moyenne =", moyenne)
print ("calcul de zlambda par un calcul de coin de table     lambda_coindetable =", lambda_coindetable)
print ('===============================================================================================')

jbavard = 1 

NN = 50 
print ("nombre de points pour les graphiques                                 NN =", NN)

jbavard = 2

if (interpol==2) :
    uuu, Sigma, VVP2, psilambda, psitj   = genere_Sigma_VV_psi_P2 (jbavard, v00, v12, v11, zlambda, NN)
    if (jbavard>=3) :
        print ('psilambda') ; print(psilambda) ; print ('psitj') ; print(psitj) 
    if (jbavard>=2) :
        poubelle = graphe_Sigma (jbavard, NN, uuu, Sigma)
        poubelle = graphe_VV (jbavard, NN, uuu, VVP2) 
        poubelle = graphe_psi_de_uu (jbavard, NN, uuu, psilambda) 
        poubelle = graphe_double_psi (jbavard, NN, uuu, psilambda, psitj)

if (interpol==3) :
    uuu, Sigma, VV, psilambda, psi00, psi11, psi = genere_Sigma_VV_psi_P1_par_morceaux (jbavard, v00, v12, v11, zlambda, NN) 
    if (jbavard>=3) :
        print (uuu) ; print (psilambda)
    if (jbavard>=2) :
        poubelle = graphe_Sigma (jbavard, NN, uuu, Sigma)
        poubelle = graphe_VV (jbavard, NN, uuu, VV) 
        poubelle = graphe_psi_de_uu (jbavard, NN, uuu, psilambda) 
        poubelle = graphe_double_psi (jbavard, NN, uuu, psi00, psi11)


print ('===============================================================================================')
print ("calcul approche de l integrale pour la valeur initiale de lambda") 

jbavard  = 1 
intappro = trapezes_psi_pour_Sigma_generale (jbavard,interpol,v00, v12, v11, zlambda,NN)
print ("integrale approchee                                            intappro =", intappro)


print ('===============================================================================================')
print ("calcul de la longueur exacte de l intervalle pour la valeur initiale de lambda")  

jbavard = 1
if (interpol==2) : intex = int_exacte_03juin (jbavard, v00, v12, v11, zlambda) 
if (interpol==3) : intex = int_exacte_28mai (jbavard, v00, v12, v11, zlambda) 
print ("integrale exacte                                                  intex =", intex)
jbavard = 1

print ('===============================================================================================')
print ("quelques manips simples pour localiser graphiquement la valeur propre exacte") 

NN = 50 
dll = (llmax-llmin)/NN  
zll = np.zeros(NN+1) ; intp4 = np.zeros(NN+1)
for j in range(NN+1) :
    zll[j] = llmin+j*dll
    if (interpol==2) : intp4[j] =  int_exacte_03juin (jbavard, v00, v12, v11, zll[j])
    if (interpol==3) : intp4[j] =  int_exacte_28mai (jbavard, v00, v12, v11, zll[j])
derive_integrale = (intp4[NN] - intp4[0])/(zll[NN]- zll[0])
print ("derivee de l integrale par rapport a lambda            derive_integrale =", derive_integrale)
jbavard  = 1
poubelle = graphe_integrale_p4_exacte (jbavard, llmin, llmax, NN, zll, intp4) 

jbavard = 0
print ('===============================================================================================')
print ("calcul de la valeur de lambda exacte avec un algorithme de quasi-Newton")

nbnewton = 12 ; ll = .5*(llmin+llmax)  
print ('algorithme de quasi-Newton avec la fonction elliptique') 
print ("                                                    nombre d iterations =", nbnewton)
for knewton in range(nbnewton) :
    if (interpol==2) : integral = int_exacte_03juin (jbavard, v00, v12, v11, ll)
    if (interpol==3) : integral = int_exacte_28mai (jbavard, v00, v12, v11, ll)
    ddll = (1.-integral)/derive_integrale
    ll = ll + ddll
    if (jbavard>=2) : print (ll)
lambda_exact_v1 = ll 
print ('premiere valeur de lambda convergee                     lambda_exact_v1 =', lambda_exact_v1)


jbavard = 1
print ('===============================================================================================')
print ("second algorithme de quasi-Newton")
epsilon = .000001 
print ('reglage de parametre pour le calcul de la derivee discrete      epsilon =', epsilon)
ll = lambda_exact_v1
llplus = lambda_exact_v1*(1+epsilon) ; llmoins = lambda_exact_v1*(1-epsilon) 
if (interpol==2) :
    intplus  =  int_exacte_03juin (jbavard, v00, v12, v11, llplus)
    intmoins =  int_exacte_03juin (jbavard, v00, v12, v11, llmoins)
if (interpol==3) :
    intplus  =  int_exacte_28mai (jbavard, v00, v12, v11, llplus)
    intmoins =  int_exacte_28mai (jbavard, v00, v12, v11, llmoins)
derive_integrale = (intplus - intmoins)/(llplus-llmoins)
for knewton in range(nbnewton) :
    if (interpol==2) : integral = int_exacte_03juin (jbavard, v00, v12, v11, ll)
    if (interpol==3) : integral = int_exacte_28mai (jbavard, v00, v12, v11, ll)
    ddll = (1.-integral)/derive_integrale
    ll = ll + ddll
    if jbavard >= 2 : print (ll)
lambda_exact = ll 
print ('seconde valeur de lambda convergee                         lambda_exact =', lambda_exact)


print ('===============================================================================================')
print ("convergence de lambda pour NN de plus en plus grand")

NN = 100
print ('seconde valeur de lambda convergee                         lambda_exact =', lambda_exact)
print ("nombre de mailles pour le calcul de l integrale par les trapezes     NN =", NN)

jbavard = 1
zlambdaNN, ordrecv =  calcule_ordre_de_convergence  (jbavard, interpol, v00, v12, v11, zlambda, NN, lambda_exact, nbnewton)

print ('valeur numerique de zlambda pour NN mailles et une approximation affine')
print ('                                                              zlambdaNN =', zlambdaNN)
print ("ordre de convergence de l'approximation numerique               ordrecv =", ordrecv)

jbavard = 1
int,dxi,err = calcul_numerique_integrale (jbavard, interpol, v00, v12, v11, zlambdaNN, NN) 
if (jbavard>=2):
    print ('integrale'), print(int)

print ('===============================================================================================')
print ('===============================================================================================')
