



############  
## 
##   thn_bibliotheque01.py      
##                                origine :  bibliotheque01.py            
##   bibliotheque de sous-programmes pour les jobs python 3
##   fd, 27, 28, 30 mai, 03, 04, 05, 14, 15, 17 juin 2021 
##   fd, 16, 17, 18 fevrier 2023, 18 mars 2024 
############################################################################

import numpy as np
import scipy as sp
from scipy.special import ellipk 
import matplotlib.pyplot as plt 
from pylab import savefig, title
from math import sin, cos, acos, asin, atan , pi, sqrt, exp, atan , tan, asin, log, floor, tan, tanh 
import matplotlib.animation as animation

from matplotlib.font_manager import FontProperties
from mpl_toolkits.axes_grid1 import host_subplot





##################################################################################
def affecte_flag (jbavard,flag,interpol) :
##################################################################################
###   31 mai 2021: affectation des valeurs numeriques en fonction du parametre 'flag'
###   03 juin 2021: enrichissement pour prendre en compte le cas P2 
###   17 fevrier 2023 : mise en forme finale  
##################################################################################
    if jbavard >= 2 : print ("sous-programme 'affecte_flag' : pretraitement")
##################################################################################
        
    if (flag==0) :
        v00 = 1. ; v12 = 1.  ; v11 = 1. ; zlambda = 10. ; llmin = 10.7 ; llmax = 11.
    if (flag==1) :
        v00 = 0. ; v12 = 1.  ; v11 = 2. ; zlambda = 10. ; llmin = 11.4 ; llmax = 11.42
    if (flag==2) :
        v00 = 2. ; v12 = -1. ; v11 = 4. ;
        zlambda = 19. ; llmin = 18. ; llmax = 19.   
    if (flag==3) :
        v00 = 8. ; v12 = 6.  ; v11 = 3. ; zlambda = 1.89 ;
        if (interpol==2) : llmin = 1.85 ; llmax = 1.88
        if (interpol==3) : llmin = 1.89 ; llmax = 1.90
    if (flag==4) :
        v00 = 2. ; v12 = .1  ; v11 = 4. 
        if (interpol==2) : zlambda = 14.  ; llmin =  14. ; llmax = 15. 
        if (interpol==3) : zlambda = 8.   ; llmin = 8  ; llmax = 9.   
    if (flag==5) :
        v00 = 8. ; v12 = 5.  ; v11 = 3. ;
        if (interpol==2) : zlambda = 2.1 ; llmin = 2. ; llmax = 2.3   
        if (interpol==3) : zlambda = 2.1 ; llmin = 2.10 ; llmax = 2.12  
    if (flag==6) :
        v00 = 1. ; v12 = .4  ; v11 = 1. ;
        if (interpol==2) : zlambda = 20. ; llmin =  19.6 ; llmax = 20. 
        if (interpol==3) : zlambda = 16. ; llmin =  16. ; llmax = 17.  
    if (flag==7) :
        alpha = .95 ; mu = 1. ; dd = -.15 
        v00 = mu*(1-alpha) ;  v12 = mu*(1+dd) ; v11 = mu*(1+alpha)  
        v00 = .5 ; v12 = 8.5 ; v11 = 19.5 ;
        if (interpol==2) : zlambda = 1.3 ; llmin =  1.1 ; llmax = 1.5   
        if (interpol==3) : zlambda = 1.3 ; llmin =  1.1 ; llmax = 1.5   
    if (flag==8) :
        v00 = 19.5 ; v12 = 8.5 ; v11 = 0.5 ;
        if (interpol==2) : zlambda = 1.3 ;  llmin =  1.2 ; llmax = 1.4  
        if (interpol==3) : zlambda = 1.3 ;  llmin =  1.1 ; llmax = 1.5  
    if (flag==9) :
        v00 = 3. ; v12 = 6.  ; v11 = 8. ;
        if (interpol==2) : zlambda = 2. ; llmin = 1.8 ; llmax = 1.90 
        if (interpol==3) : zlambda = 2. ; llmin = 1.89 ; llmax = 1.90 
    if (flag==10) :
        v00 = 50. ; v12 = 1.  ; v11 = 10. ;
        if (interpol==2) : zlambda = 1.7 ; llmin = 1.75 ; llmax = 1.78    
        if (interpol==3) : zlambda = .908 ; llmin = .90 ; llmax = .92    
    if (flag==11) :
        v00 = 1. ; v12 = 10.  ; v11 = 5. ;
        if (interpol==2) : zlambda = 1.4 ; llmin = 1.3 ; llmax = 1.35   
        if (interpol==3) : zlambda = 1.7 ; llmin = 1.52 ; llmax = 1.6   
    if (flag==12) :
        v00 = 1. ; v12 = 1.  ; v11 = 0. ;
        if (interpol==2) : zlambda = 13. ;  llmin = 12.5 ; llmax = 12.8 
        if (interpol==3) : zlambda = 14. ;  llmin = 14. ; llmax = 14.25   


    if (flag==0) :      print ('flag = 0         cas test Sigma(u) constant')
    if (flag==1) :      print ('flag = 1         cas test Sigma(u) lineaire')
    if (flag==2) :      print ('flag = 2         cas test Sigma(u) lineaire donne en trois points, cas fd difficile')
    if (flag==3) :      print ("flag = 3         cas test Sigma(u) lineaire donne en trois points, cas Oliver facile")
    if (flag==4) :      print ('flag = 4         cas test Sigma(u) lineaire donne en trois points, cas fd moins difficile')
    if (flag==5) :      print ('flag = 5         cas test Sigma(u) donne en trois points, variante convexe du cas d Olivier')
    if (flag==6) :      print ('flag = 6         cas test Sigma(u) donne en trois points, poles complexes ?')
    if (flag==7) :      print ('flag = 7         cas test Sigma(u) donne en trois points, deux racines reelles negatives')
    if (flag==8) :      print ('flag = 8         cas test Sigma(u) donne en trois points, deux racines reelles superieures a un')  
    if (flag==9) :      print ('flag = 9         cas test Sigma(u) concave presque lineaire')
    if (flag==10) :     print ('flag = 10        cas test Sigma(u) donne en trois points, cas mechant en vallon')
    if (flag==11) :     print ('flag = 11        cas test Sigma(u) donne en trois points, cas en chapeau chinois')
    if (flag==12) :     print ('flag = 12        cas test Sigma(u) donne en trois points, raccord P2-P3')

    if (interpol==0) :
        print ('interpol = 0     on se contente de la valeur moyenne des donnees de Sigma') 
        print ('                 le calcul de coin de table suffit') 
        print ('                 on fait tourner le job avec une interpolation P1 par morceaux') 
        moyenne = .25*v00 +.5*v12 + .25*v11 
        v00new = moyenne ; v12new = moyenne ; v11new = moyenne   
        lambda_coindetable = (1.+pi*pi)/moyenne ; zlambda = lambda_coindetable
        llmin = .9*zlambda ; llmax=1.1*zlambda

    if (interpol==1) :
        print ('interpol = 1     on suppose fonction Sigma donnee par une interpolation affine') 
        print ('                 le seul test affine suppose flag=1')
        print ('                 sinon on force l interpolation affine en ignorant v12')
        moyenne = .5*v00 +.5*v11 
        v00new = v00 ; v12new = moyenne ; v11new = v11   
        if (flag==0) :  zlambda = 10. ; llmin = 10.7 ; llmax = 11.
        if (flag==1) :  zlambda = 11.4 ; llmin = 11.4 ; llmax = 11.42
        if (flag==2) :  zlambda = 3.65 ; llmin = 3.62 ; llmax = 3.66 
        if (flag==3) :  zlambda = 1.99 ;  llmin = 1.99 ; llmax = 2.
        if (flag==4) :  zlambda = 3.65 ; llmin = 3.6 ; llmax = 3.7
        if (flag==5) :  zlambda = 2. ; llmin = 1.9 ; llmax = 2.1   
        if (flag==6) :  zlambda = 11.4 ; llmin = 11.4 ; llmax = 11.42
        if (flag==7) :  zlambda = 1.1 ; llmin =  1.1 ; llmax = 1.2   
        if (flag==8) :  zlambda = 1.1 ; llmin =  1.1 ; llmax = 1.2   
        if (flag==9) :  zlambda = 1.99 ;  llmin = 1.99 ; llmax = 2.
        if (flag==10) : zlambda = .37 ; llmin = .35 ; llmax = .4 
        if (flag==11) : zlambda = 3.8  ; llmin = 3.5  ; llmax = 4. 
        if (flag==12) : zlambda = 23. ;  llmin = 22. ; llmax = 24.
        
    if (interpol==2) :
        print ('interpol = 2     la fonction Sigma est une interpolation vraiment polynomiale de degre 2')
        print ('attention : les cas flag=0, 1 et 2 se plantent si interpol=2 et c est tout a fait normal !')
        v00new = v00 ; v12new = v12 ; v11new = v11   
        
    if (interpol==3) :
        print ('interpol = 3     la fonction Sigma est affine par morceaux')
        v00new = v00 ; v12new = v12 ; v11new = v11   

    if (interpol==4) :
        v00new = Sigma_historic_p2 (0.,v00, v12, v11) 
        v12new = Sigma_historic_p2 (.5,v00, v12, v11) 
        v11new = Sigma_historic_p2 (1.,v00, v12, v11) 
        print ('interpol = 4     la fonction Sigma est quadratique mais on la modifie')
        print ('                 avec une approche variationnelle pour la rendre affine')
        print ('attention : les cas flag=2 et 10 se plantent si interpol=4 et c est tout a fait normal !')
        if (flag==0) :  zlambda = 10. ; llmin = 10.7 ; llmax = 11.
        if (flag==1) :  zlambda = 11.4 ; llmin = 11.4 ; llmax = 11.42        
        if (flag==2) :  zlambda = 19. ; llmin = 18. ; llmax = 19.  
        if (flag==3) :  zlambda = 1.86 ; llmin = 1.85 ; llmax = 1.87
        if (flag==4) :  zlambda = 18.  ; llmin =  17.8 ; llmax = 18.1 
        if (flag==5) :  zlambda = 2.1 ; llmin = 2.1 ; llmax = 2.2
        if (flag==6) :  zlambda = 21. ; llmin = 20.5 ; llmax = 21.5        
        if (flag==7) :  zlambda = 1.3 ; llmin =  1.2 ; llmax = 1.4       
        if (flag==8) :  zlambda = 1.3 ; llmin =  1.2 ; llmax = 1.4       
        if (flag==9) :  zlambda = 1.86 ; llmin = 1.85 ; llmax = 1.87        
        if (flag==10) : zlambda = 1.5 ; llmin = 1. ; llmax = 2.       
        if (flag==11) : zlambda = 1.3 ; llmin = 1.  ; llmax = 1.5        
        if (flag==12) : zlambda = 12. ;  llmin = 11. ; llmax = 13.
        

    if (interpol==5) :
        v00new = Sigma_historic_p1 (0.,v00, v12, v11) 
        v12new = Sigma_historic_p1 (.5,v00, v12, v11) 
        v11new = Sigma_historic_p1 (1.,v00, v12, v11) 
        print ('interpol = 5     la fonction Sigma est affine par morceaux mais on la modifie')
        print ('                 avec une approche variationnelle pour la rendre affine')
        if (flag==0) :  zlambda = 10. ; llmin = 10.7 ; llmax = 11.
        if (flag==1) :  zlambda = 11.4 ; llmin = 11.4 ; llmax = 11.42       
        if (flag==2) :  zlambda = 27.7 ; llmin = 27.5 ; llmax = 28.
        if (flag==3) :  zlambda = 1.9 ; llmin = 1.8 ; llmax = 2.     
        if (flag==4) :  zlambda = 9.5  ; llmin =  9. ; llmax = 10.        
        if (flag==5) :  zlambda = 2.1 ; llmin = 2. ; llmax = 2.2        
        if (flag==6) :  zlambda = 17.5 ; llmin = 17. ; llmax = 18.     
        if (flag==7) :  zlambda = 1.3 ; llmin =  1.2 ; llmax = 1.3
        if (flag==8) :  zlambda = 1.3 ; llmin =  1.2 ; llmax = 1.3        
        if (flag==9) :  zlambda = 1.9 ; llmin = 1.8 ; llmax = 2.
        if (flag==10) : zlambda = 1.1 ; llmin = 1. ; llmax = 1.2
        if (flag==11) : zlambda = 1.45 ; llmin = 1.45  ; llmax = 1.5        
        if (flag==12) : zlambda = 13.5 ;  llmin = 13. ; llmax = 14.


    print ('valeurs initiales avant le pretraitement')
    print (' en x = 0              v00 =', v00)
    print (' en x = 1/2            v12 =', v12)
    print (' en x = 1              v11 =', v11)
    print ('valeurs modifiees a l issue du pretraitement')
    print (' en x = 0           v00new =', v00new)
    print (' en x = 1/2         v12new =', v12new)
    print (' en x = 1           v11new =', v11new)
    v00 = v00new ;  v12 = v12new ; v11 = v11new 


    ###  sortie du resultat dans un fichier
    if jbavard >= 2 :
        fichier = open("thn-data-sigma-brut", 'w')
        fmt = "{:20.13e} "*2 + "\n"
        fichier.write(fmt.format(0, v00))
        fichier.write(fmt.format(.5, v12))
        fichier.write(fmt.format(1., v11))
        fichier.close()

    print ('===============================================================================================')
    return v00,v12,v11,zlambda,llmin,llmax
#####################################################################################################################



##################################################################################
def int_exacte_v4 (jbavard,pp,gg) :
##################################################################################
##  fd 26 mai ; integrale entre 0 et 1 de 1 sur racine (psi)
##              psi(u) = u*(1.-u)*(u-p)*(u-g),   pp<0 et gg<0
##################################################################################

    aaa = -pp**2 + gg**2 + pp - gg
    bbb = -pp**2 - gg**2 + pp + gg
    det = bbb**2 - aaa**2
    det1 = 4*pp*gg*(pp-1.)*(gg-1.)
    err = det - det1
    
    bb = (bbb-sqrt(det))/aaa
    aa = bb*(pp-gg) - pp - gg + 1
    alpha = -.5*(1.-aa)/aa
    eq01 = alpha*(aa+1.) + (1.-aa)*(1.-alpha) 
    eq02 = (1.-aa)*(1.-alpha) - (bb-1.)*(alpha-pp) 
    eq03 = (bb-1.)*(alpha-pp) - (bb+1.)*(gg-alpha) 
    beta = -alpha*aa
    mm = aa**2/(bb**2)
    K2m = sp.special.ellipk(mm)
    intex = 2.*sqrt((1.-aa**2)*(bb**2-1.))*K2m/(abs(alpha-beta)*bb)
    
    if jbavard >= 2 : 
        print ('===================================================================================')
        print ('int_exacte_v4 : deux zeros negatifs') 
        print ('err') ; print(err) 
        print ('bb') ; print(bb) 
        print ('aa') ; print(aa) 
        print ('alpha') ; print(alpha) 
        print ("eq01") ; print (eq01)
        print ("eq02") ; print (eq02)
        print ("eq03") ; print (eq03)
        print ('beta') ; print(beta)
        print ('mm') ; print(mm)
        print ('intex') ; print(intex)
        print ('===================================================================================')

    return intex 


##################################################################################
def int_exacte_v3 (jbavard,pp,gg) :
##################################################################################
##  fd 26 mai ; integrale entre 0 et 1 de 1 sur racine (psi)
##              psi(u) = u*(1.-u)*(u-p)*(u-g),   pp > 1 et gg > 1
##              det doit etre positif ! 
##################################################################################

    aaa = -pp**2 + gg**2 + pp - gg
    bbb = pp**2 + gg**2 - pp - gg
    det = bbb**2 - aaa**2
    det1 = 4*pp*gg*(pp-1.)*(gg-1.)
    err = det - det1
    
    bb = (bbb+sqrt(det))/aaa
    aa = bb*(pp-gg) + pp + gg - 1
    alpha = .5*(pp+gg) + .5*(pp-gg)/bb
    eq01 = (-2)*aa*alpha + aa + 1.
    eq02 = -aa*alpha + alpha*bb - bb*pp + aa - pp + 1
    eq03 = (-2)*alpha*bb + bb*pp + bb*gg + pp - gg
    beta = alpha*aa
    mm = aa**2/(bb**2)
    K2m = sp.special.ellipk(mm)
    intex = 2.*sqrt((1.-aa**2)*(bb**2-1.))*K2m/((alpha-beta)*bb)
    
    if jbavard >= 2 : 
        print ('===================================================================================')
        print ("sous-programme 'int_exacte_v3' : deux zeros superieurs a 1") 
        print ('err') ; print(err) 
        print ('bb') ; print(bb) 
        print ('aa') ; print(aa) 
        print ('alpha') ; print(alpha) 
        print ("eq01") ; print (eq01)
        print ("eq02") ; print (eq02)
        print ("eq03") ; print (eq03)
        print ('beta') ; print(beta)
        print ('mm') ; print(mm)
        print ('intex') ; print(intex)
        print ('===================================================================================')
        
    return intex 

##################################################################################
def int_exacte_v2 (aa,bb) :
##################################################################################
##  fd 26 mai ; integrale entre 0 et a de 1 sur racine (psi)    
##              psi de la forme (a^2-u^2)(b^2+u^2) 
##################################################################################

    mm = -(aa**2/bb**2)
    K2m = sp.special.ellipk(mm)

    ##### print ('aa') ; print(aa) 
    ##### print ('bb') ; print(bb) 
    ##### print ('mm') ; print(mm) 

    intex = K2m/abs(bb)     
    return intex 


##################################################################################
def trapezes_v3 (pp,gg,NN) :
##################################################################################
##  fd 26 mai ; formules des trapezes pour psi de la forme u(1-u)(p-u)(g-u)   
##              avec p>1 et gg > 1
##################################################################################

    dtheta = pi/(2.*NN)
    psi =  np.zeros(NN+1)

    for j in range(NN+1) :
        tt = j*dtheta
        sin2tt = sin(tt)**2
        p4 = (pp-sin2tt)*(gg-sin2tt) 
        psi[j] = 1./sqrt(p4)

    int = 0.
    int = int + .5*psi[0] + .5*psi[NN]
    
    for j in range(1,NN) :
        # print (j)
        int = int + psi[j]
    int = 2*dtheta*int
    
    ### print ('int') ; print(int)

    return int

##################################################################################
def trapezes_v2 (aa,bb,NN) :
##################################################################################
##  fd 21 mai ; formules des trapezes pour psi de la forme u(1-u)(b^2+u*a^2)   
##  fd 27 mai : il me semble qu il manque un facteur 2    
##################################################################################

    dtheta = pi/(2.*NN)
    theta = np.zeros(NN+1) ; psi =  np.zeros(NN+1)

    for j in range(NN+1) :
        tt = j*dtheta
        sin2tt = sin(tt)**2
        p2 = bb**2 + (aa**2)*sin2tt
        theta[j] = tt
        psi[j] = 1./sqrt(p2)

    int = 0.
    int = int + .5*psi[0] + .5*psi[NN]
    
    for j in range(1,NN) :
        int = int + psi[j]
    int = dtheta*int
    
    return int 
    

##################################################################################
def trapezes_psi (sigma,delta,NN) :
##################################################################################
##  fd 21 mai ; formules des trapezes pour psi p4 avec des zeros complexes 
##     sigma : somme des racines ; pm delta : parie imaginaire des racines 
##     27 mai : attention, le coefficient du terme en u**4 est egal a 1   
##################################################################################

    dtheta = pi/(2.*NN)
    psi =  np.zeros(NN+1)

    for j in range(NN+1) :
        tt = j*dtheta
        uu = sin(tt)**2
        p2 = (uu-.5*sigma)**2 + delta**2 
        psi[j] = 1./sqrt(p2)

    int = 0.
    int = int + .5*psi[0] + .5*psi[NN]
    
    for j in range(1,NN) :
        # print (j)
        int = int + psi[j]
    int = 2.*dtheta*int
    
    ### print ('int') ; print(int)

    return int


##################################################################################
def int_exacte_complexes (jbavard,sigma,delta) :
##################################################################################
##  fd 21 mai 2021 ; deux racines complexes 
##     modif le 27 mai pour traiter aussi le cas sigma > 1 
##     modif le 03 juin pour forcer la positivite  
##################################################################################

    epsilon = 1.e-14
    ### print ('epsilon') ; print(epsilon) 
    if (abs(sigma-1.)>epsilon) :  
        deltaprime = (delta**2+.25*sigma**2)*(delta**2+(.5*sigma-1.)**2)
        if (sigma<1) :     alpha = -(sqrt(deltaprime) + delta**2 + .25*sigma**2)/(1.-sigma)
        if (sigma>1) :     alpha = (sqrt(deltaprime) + delta**2 + .25*sigma**2)/(sigma-1.)
        equation = (1.-sigma)*alpha*alpha + (2.*delta*delta+(sigma*sigma/2.))*alpha - delta*delta - (sigma*sigma/4.)
        aa = 1./(1.-2.*alpha)
        bb = delta/(alpha-.5*sigma)
        beta = -aa*alpha
        mm = -(aa**2/bb**2)
        K2m = sp.special.ellipk(mm)
        intex = 2.*sqrt((1-aa*aa)*(1.+bb*bb))*K2m/(abs((beta-alpha)*bb))

        if (jbavard>=2) : 
            print ('==========================================================')  
            print ('int_exacte_complexes : deux racines complexes sigma different de 1')  
            print ('sigma') ; print(sigma)  
            print ('delta') ; print(delta) 
            print ('alpha') ; print(alpha) 
            print ('equation') ; print(equation) 
            print ('aa') ; print(aa) 
            print ('bb') ; print(bb) 
            print ('beta') ; print(beta) 
            print ('mm') ; print(mm) 
            print ('K2m') ; print(K2m) 
            print ('intex  resultat partiel pour le calcul de l integrale') ; print(intex) 
            print ('==========================================================')  

    else : intex = int_exacte_psi_sigma_1 (jbavard,delta)
    
    return intex

##################################################################################
def int_exacte_psi_sigma_1 (jbavard,delta) :
##################################################################################
##  fd 21 mai ; cas ou sigma = 1 pour deux racines complexes 
##             la partie imaginaire vaut delta  
##################################################################################
   
    mm = -.25/(delta*delta) 
    K2m = sp.special.ellipk(mm)

    if (jbavard>=2): 
        print ('===================================================================================')
        print ('la somme des racines complexes est exactement egale a 1') 
        print ('mm') ; print(mm) 
        print ('===================================================================================')

    intex = 2.*K2m/(abs(delta))
    return intex

##################################################################################
def int_exacte (pp,gg) :
##################################################################################
###   17 mai ; cas de deux racines de signes contraires deja connues 
###            pp < 0 < 1 < gg 
##################################################################################

    gA = -sqrt((gg*(gg-pp)/(1.-pp)))
    gB = sqrt((1.-pp)*(gg-pp)/gg)

    aa = (gA+1.)/(gA-1.)
    bb = (gB+1.)/(gB-1.)
    mm = 1.-(aa**2/bb**2)
    K2m = sp.special.ellipk(mm)

    #### print ('aa') ; print(aa) 
    #### print ('bb') ; print(bb) 
    #### print ('mm') ; print(mm) 

    intex = (1.-(aa/bb))*K2m/sqrt(gg-pp)
   
    return intex

##################################################################################
def int_exacte_27mai (jbavard, v00, v12, v11, zlambda) :
##################################################################################
###   27 mai ; cas de deux racines stricteùnt negatives    pp < 0  et  gg < 0  
###                                 ou superieures a un :  pp > 1  et  gg > 1   
##################################################################################

    mu = .5*(v00+v11) ; alpha = (v11/mu)-1. ; dd = (v12/mu)-1.
    xi = zlambda*mu 
    aa  = 2.*xi*dd/3.  
    gamma  = 1. - (abs(alpha)/3.) + 2.*dd/3. 
    somme  = 1 + (alpha/dd)   
    prodt  = (1 - xi + (alpha*xi/3.) - (2.*dd*xi)/3.)/aa  
    det = 4.*xi*((5.*dd*dd + alpha*alpha + 6.*dd)*xi - 6.*dd  )/(9.*aa*aa)
    pp = .5*(somme-sqrt(det)) ; gg = .5*(somme+sqrt(det))

    if ((pp<0)&(gg<0)) : intex = int_exacte_v4 (jbavard,pp,gg)/sqrt(-aa)
    if ((pp>1.)&(gg>1.)) : intex = int_exacte_v3 (jbavard,pp,gg)/sqrt(-aa)
    return intex 

##################################################################################
def int_exacte_17mai (jbavard, v00, v12, v11, ll) :
##################################################################################
###   -cc*pr + ((-1)/3)*v00*ll + ((-2)/3)*v12*ll + 1
###   -cc*ss + ((-2)/3)*v00*ll + 2/3*v12*ll
###   17 mai ; cas de deux racines de signes contraires   pp < 0 < 1 < gg 
###   27 mai ; on suppose aussi cc positif...  attention !  
##################################################################################
##################################################################################

     cc = (-v00 + 2.*v12 - v11)*ll/3.  
     produit = (1.-((v00 + 2.*v12)*ll)/3.)/cc 
     somme  =  2.*(-v00 + v12)*ll/(3.*cc)
     det = somme**2 - 4.*produit
     pp = (somme - sqrt(det))/2.
     gg = (somme + sqrt(det))/2.
     intex = int_exacte (pp,gg)
     valeur_exacte = intex/sqrt(cc) 

     if (jbavard>=2) :
         print ('v00') ; print (v00)
         print ('v12') ; print (v12)
         print ('v11') ; print (v11)
         print ('lambda  ll') ; print (ll)
         print ('cc') ; print (cc)
         print ('produit') ; print (produit)
         print ('somme') ; print (somme)
         print ('det') ; print (det)
         print ('pp') ; print (pp)
         print ('gg') ; print (gg)
         print ('valeur_exacte') ; print (valeur_exacte)
         print ('===================================================================================')

     return valeur_exacte

##################################################################################
def int_exacte_26mai (jbavard, v00, v12, v11, ll) :
##################################################################################
###   -cc*pr + ((-1)/3)*v00*ll + ((-2)/3)*v12*ll + 1
###   -cc*ss + ((-2)/3)*v00*ll + 2/3*v12*ll
###   26 mai ; cas de deux racines complexes  
###            attention : plante dans le gas lineaire car cc est nul   
##################################################################################
##################################################################################

     cc = (-v00 + 2.*v12 - v11)*ll/3.  
     produit = (1.-((v00 + 2.*v12)*ll)/3.)/cc 
     somme  =  2.*(-v00 + v12)*ll/(3.*cc)
     det = somme**2 - 4.*produit
     imaginaire = .5*sqrt(-det)
     valeur_exacte = int_exacte_complexes (jbavard,somme,imaginaire)/sqrt(-cc) 

     if (jbavard>=2) :
         print ('===================================================================================')
         print ("sous-programme 'int_exacte_26mai'")
         print ('v00') ; print (v00)
         print ('v12') ; print (v12)
         print ('v11') ; print (v11)
         print ('lambda  ll') ; print (ll)
         print ('cc') ; print (cc)
         print ('produit') ; print (produit)
         print ('somme') ; print (somme)
         print ('det') ; print (det)
         print ('valeur_exacte') ; print (valeur_exacte)
         print ('===================================================================================')

     return valeur_exacte

##################################################################################
def graphe_integrale_p4_exacte (jbavard, llmin, llmax, NN, zll, intp4) :
##################################################################################

    if jbavard >= 2 : print ("sous-programme   'graphe_integrale_p4_exacte'") 
    ymin = min(intp4) ; ymax = max(intp4)     
    xmin = llmin ; xmax = llmax 

    fig, ax = plt.subplots(figsize=(11,6))
    ax.set_xlim(xmin,xmax) ; ax.set_ylim(ymin,ymax)
    ax.set_title('variation de l integrale elliptique exacte en fonction de lambda        François Dubois          26 mai 2021')
    
    if (jbavard >= 3) : print ('zll') ; print (zll) 
    if (jbavard >= 3) : print ('intp4') ; print (intp4) 

    ax.plot ( zll, intp4 , 'b',   marker = '*' , markersize = 3 ,  linewidth=.3 ,  label="integrale elliptique") 
    ax.plot ( [llmin,llmax] , [1.,1.] , 'k',   marker = '*' , markersize = 0 ,  linewidth=.5 ,  label="valeur cible") 

    ax.legend(loc='best')
    plt.draw()
    if jbavard >= 2 : plt.savefig ('thn-graphique-integrale-p4.pdf', bbox_inches='tight',  pad_inches=0, transparent=True)
  
    return xmin

##################################################################################
def graphe_psi_de_uu (jbavard, NN, uuu, psilambda) :
##################################################################################

    if jbavard >= 2 : print ("sous-programme 'graphe_psi_de_uu'") 
    ymin = min(psilambda) ; ymax = 1.01*max(psilambda) ; ymin = min(ymin,-.01*ymax) 
    xmin = -.01 ; xmax = 1.01 
    ######## print ('hello') ; print (ymin) 
    
    fig, ax = plt.subplots(figsize=(11,6))
    ax.set_xlim(xmin,xmax) ; ax.set_ylim(ymin,ymax)
    ax.set_title('fonction psi indice lambda en fonction de u            François Dubois             27 mai 2021')
    
    ax.plot ( uuu, psilambda , 'b',   marker = '*' , markersize = 3 ,  linewidth=.3 ,  label="psi(u)") 
    ### ax.plot ( [llmin,llmax] , [1.,1.] , 'k',   marker = '*' , markersize = 0 ,  linewidth=.5 ,  label="valeur cible") 

    ax.legend(loc='best')
    plt.draw()
    if jbavard >= 2: plt.savefig ('thn-graphique-psi_de_u.pdf', bbox_inches='tight',  pad_inches=0, transparent=True)
  
    return xmin

##################################################################################


##################################################################################
def graphe_double_psi (jbavard, NN, uuu, psi0, psi1) :
##################################################################################

    if jbavard >= 2 : print ("sous-programme 'graphe_double_psi'") 
    ymin0 = min(psi0) ; ymin01 = min(psi1) ; ymin = min(ymin0, ymin01)
    ymax0 = max(psi0) ; ymax01 = max(psi1) ; ymax = max(ymax0, ymax01)  
    ymax = 1.01*ymax ; ymin = min(ymin,-.01*ymax) 
    xmin = -.01 ; xmax = 1.01 
    ######## print ('hello') ; print (ymin) 
    
    fig, ax = plt.subplots(figsize=(11,6))
    ax.set_xlim(xmin,xmax) ; ax.set_ylim(ymin,ymax)
    ax.set_title('deux fonctions psi cubiques pour un raccord C1              François Dubois            28 mai 2021')
    
    ax.plot ( uuu, psi0 , 'b',   marker = '*' , markersize = 3 ,  linewidth=.3 ,  label="psi0") 
    ax.plot ( uuu, psi1 , 'r',   marker = '*' , markersize = 3 ,  linewidth=.3 ,  label="psi1") 
    ax.plot ( [0,1] , [0,0] , 'k',   marker = '*' , markersize = 0 ,  linewidth=.3 ,  label="zero") 

    ax.legend(loc='best')
    plt.draw()
    if jbavard >= 2 : plt.savefig ('thn-graphique-double-psi.pdf', bbox_inches='tight',  pad_inches=0, transparent=True)

    ###  sortie du resultat dans un fichier 
    if jbavard >= 2 :
        fichier = open("thn-data-double-psi", 'w')
        fmt = "{:20.13e} "*3 + "\n"
        fmt2 = "{:20.13e} "*7 + "\n"
        for k in range(NN+1) :
           fichier.write(fmt.format(uuu[k], psi0[k], psi1[k]))
        fichier.close()

    
    return xmin

##################################################################################


##################################################################################
def int_exacte_28mai (jbavard, v00, v12, v11, zlambda) :
##################################################################################
###   28 mai ; cas d une fonction Sigma positive et affine par morceaux   
###   29 mai  traitement du cas de zeros complexes conjugues   
##################################################################################
##################################################################################

    alpha = 1. - (v00/v12) ; beta = (v11/v12) - 1. ; xi = zlambda*v12

    if (jbavard>=2) : 
        print ("================================================================================") 
        print ("sous-programme 'int_exacte_28mai'") 
        print ("  cas d une fonction Sigma positive et affine par morceaux") 
        print ("alpha") ; print (alpha)
        print ("beta") ; print (beta)
        print ("zlambda") ; print (zlambda)
        print ("xi = lambda   v12") ; print (xi)
        print ("================================================================================") 
        print ("premiere fonction psi0 polynomiale de degre 3 dans la plupart des cas")

    aaa0 = -2.*alpha*xi/3.
    bbb = alpha*xi - xi + 1.
    ccc = (-5.*alpha+beta)*xi/12. + xi - 1.

    if (aaa0==0.) :
        aaa = xi - 1. 
        bbb = 1. + beta*xi/(12.*(xi-1.))
        phi0star = sqrt(2.*bbb-1.)    
        II0 = 2.*(.5*pi - atan(phi0star))/sqrt(aaa)
        if (jbavard>=2) : 
            print ("================================================================================")
            print ("contribution psi0 a l integrale si la pente a gauche est nulle")
            print ("aaa") ; print (aaa)
            print ("bbb") ; print (bbb)
            print ("phi0star") ; print (phi0star)
    else :
        if (aaa0<0) :
            aaa = -aaa0
            bbb = -bbb
            ccc = -ccc
        if (aaa0>0) : aaa = aaa0 
        det = bbb**2 - 4.*aaa*ccc
        if (jbavard>=2) : 
            print ("aaa0") ; print (aaa0)
            print ("aaa") ; print (aaa)
            print ("bbb") ; print (bbb)
            print ("ccc") ; print (ccc)
            print ("det") ; print (det)
        
        if (det<=0.) : 
            bbp = bbb/aaa
            las = sqrt(sqrt(ccc/aaa))
            mm0 = .5 - .25*bbp/(las*las) 
            phi0star = 2.*atan(1./(las*sqrt(2.))) 
            K2mzero = sp.special.ellipkinc(phi0star,mm0)
            II0 = K2mzero/(las*sqrt(abs(aaa0)))
            if (jbavard>=2) : 
                print ("================================================================================")
                print ("contribution psi0 a l integrale si le discriminant est negatif")
                print ("aaa") ; print (aaa)
                print ("bbb") ; print (bbb)
                print ("ccc") ; print (ccc)
                print ("bbp") ; print (bbp)
                print ("las") ; print (las)
                print ("mm0") ; print (mm0)
                print ("phi0star")  ; print (phi0star)
                print ("mm0")  ; print (mm0)
                print ("K2mzero")  ; print (K2mzero)
                
        if (det>0.) : 
            racpsi0moins = (-bbb-sqrt(det))/(2.*aaa) 
            racpsi0plus  = (-bbb+sqrt(det))/(2.*aaa)
            if (aaa0>0) :
                racpsi0 = racpsi0moins
                gracpsi0 = racpsi0plus
                phi0star = asin(sqrt(.5/racpsi0))
                mm0 = racpsi0 / gracpsi0
                K2mzero = sp.special.ellipkinc(phi0star,mm0)
                II0 = 2.*K2mzero/sqrt(gracpsi0*abs(aaa0)) 
                if (jbavard>=2) : 
                    print ("================================================================================")
                    print ("contribution psi0 a l integrale si le discriminant est positif ")
                    print ("cas de deux racines de meme signe")
                    print ("racpsi0moins") ; print (racpsi0moins)
                    print ("racpsi0plus")  ; print (racpsi0plus)
                    print ("racpsi0")  ; print (racpsi0)
                    ## print ("a0")  ; print (a0)
                    print ("phi0star")  ; print (phi0star)
                    print ("mm0")  ; print (mm0)
                    print ("K2mzero")  ; print (K2mzero)

            if (aaa0<0) :
                rrplus = racpsi0plus 
                rmoins = racpsi0moins 
                phi0star = asin(sqrt(.5/rrplus))
                mm0 = rrplus / rmoins
                K2mzero = sp.special.ellipkinc(phi0star,mm0)
                II0 = 2.*K2mzero/sqrt(abs(aaa0*rmoins))
                if (jbavard>=2) : 
                    print ("================================================================================")
                    print ("contribution psi0 a l integrale si le discriminant est positif ")
                    print ("cas de deux racines de signe contraire")
                    print ("rrplus") ; print (rrplus)
                    print ("rmoins")  ; print (rmoins)
                    print ("phi0star")  ; print (phi0star)
                    print ("mm0")  ; print (mm0)
                    print ("K2mzero")  ; print (K2mzero)

    if (jbavard>=2) : print ("synthese des calculs precedents   II0 =", II0)
       

    if (jbavard>=2) : 
        print ("================================================================================") 
        print ("seconde fonction psi1 polynomiale de degre 3 et exceptionnellement de drgre 2")
        print ("on est passe a la variable vv = 1 - uu")
        
    ###   aaa    2/3*beta*xi
    ###   bbb   -beta*xi - xi + 1
    ###   ccc    ((-1)/12)*alpha*xi + 5/12*beta*xi + xi - 1
    aaa1 = 2*beta*xi/3.
    bbb = -beta*xi - xi + 1.
    ccc = (-alpha + 5.*beta)*xi/12. + xi - 1.

    if (aaa1==0.) :
        aaa = xi - 1. 
        bbb = 1. - alpha*xi/(12.*(xi-1.))
        phi1star = sqrt(2.*bbb-1.)    
        II1 = 2.*(.5*pi - atan(phi1star))/sqrt(aaa)
        if (jbavard>=2) : 
            print ("================================================================================")
            print ("contribution psi0 a l integrale si la pente a droite est nulle")
            print ("aaa") ; print (aaa)
            print ("bbb") ; print (bbb)
            print ("phi1star") ; print (phi1star)
    else : 
        if (aaa1<1) :
            aaa = -aaa1
            bbb = -bbb
            ccc = -ccc
        if (aaa1>0) : aaa = aaa1
        det = bbb**2 - 4.*aaa*ccc
        if (jbavard>=2) : 
            print ("aaa1") ; print (aaa1)
            print ("aaa") ; print (aaa)
            print ("bbb") ; print (bbb)
            print ("ccc") ; print (ccc)
            print ("det") ; print (det)
        
        if (det<=0.) :
            if (aaa1<1) :
                aaa = -aaa1
                bbb = -bbb
                ccc = -ccc
            if (aaa1>0) : aaa = aaa1        
            bbp = bbb/aaa
            las = sqrt(sqrt(ccc/aaa))
            mm1 = .5 - .25*bbp/(las*las) 
            phi1star = 2.*atan(1./(las*sqrt(2.))) 
            K2mun = sp.special.ellipkinc(phi1star,mm1)
            II1 = K2mun/(las*sqrt(abs(aaa1)))
            if (jbavard>=2) : 
                print ("================================================================================")
                print ("contribution psi1 a l integrale si le discriminant est negatif")
                print ("aaa") ; print (aaa)
                print ("bbb") ; print (bbb)
                print ("ccc") ; print (ccc)
                print ("bbp") ; print (bbp)
                print ("las") ; print (las)
                print ("mm1") ; print (mm1)
                print ("phi1star")  ; print (phi1star)
                print ("mm1")  ; print (mm1)
                print ("K2mun")  ; print (K2mun)

        if (det>0.) :   
            racpsi1moins = (-bbb-sqrt(det))/(2.*aaa) 
            racpsi1plus  = (-bbb+sqrt(det))/(2.*aaa)
            if (aaa1>0) :
                racpsi1 = racpsi1moins
                gracpsi1 = racpsi1plus
                phi1star = asin(sqrt(.5/racpsi1))
                mm1 = racpsi1 / gracpsi1
                K2mun = sp.special.ellipkinc(phi1star,mm1)
                II1 = 2.*K2mun/sqrt(gracpsi1*abs(aaa1)) 
                if (jbavard>=2) : 
                    print ("================================================================================")
                    print ("contribution psi1 a l integrale si le discriminant est positif ")
                    print ("cas de deux racines de meme signe")
                    print ("racpsi1moins") ; print (racpsi1moins)
                    print ("racpsi1plus")  ; print (racpsi1plus)
                    print ("racpsi1")  ; print (racpsi1)
                    print ("phi1star")  ; print (phi1star)
                    print ("mm1")  ; print (mm1)
                    print ("K2mun")  ; print (K2mun)
            if (aaa1<0) :
                rrplus = racpsi1plus 
                rmoins = racpsi1moins 
                phi1star = asin(sqrt(.5/rrplus))
                mm1 = rrplus / rmoins
                K2mun = sp.special.ellipkinc(phi1star,mm1)
                II1 = 2.*K2mun/sqrt(abs(aaa1*rmoins))
                if (jbavard>=2) : 
                    print ("================================================================================")
                    print ("contribution psi1 a l integrale si le discriminant est positif ")
                    print ("cas de deux racines de signe contraire")
                    print ("rrplus") ; print (rrplus)
                    print ("rmoins")  ; print (rmoins)
                    print ("phi1star")  ; print (phi1star)
                    print ("mm1")  ; print (mm1)
                    print ("K2mun")  ; print (K2mun)

    if (jbavard>=2) : print ("synthese des calculs precedents   II1 =", II1)

    intex = II0 + II1 
    if (jbavard>=2) : 
        print ("================================================================================")
        print ("somme des contributions") 
        print ("intex = II0 + II1")  ; print (intex)

    return intex
##################################################################################

##################################################################################
def graphe_Sigma (jbavard, NN, uuu, Sigma) :
##################################################################################

    if jbavard >= 2: print ("sous-programme 'graphe_Sigma'")
    ymin = min(Sigma) ; ymax = max(Sigma) ;
    if (ymax==ymin) : ymax = ymin + .1 ; ymin = ymin -.1 
    ymax = ymax + .01*(ymax-ymin) ; ymin = ymin - .01*(ymax-ymin)  
    xmin = -.01 ; xmax = 1.01 
    
    fig, ax = plt.subplots(figsize=(11,6))
    ax.set_xlim(xmin,xmax) ; ax.set_ylim(ymin,ymax)
    ax.set_title('fonction Sigma en fonction de u               François Dubois                31 mai 2021')
    
    ax.plot ( uuu, Sigma , 'b',   marker = '*' , markersize = 3 ,  linewidth=.3 ,  label="Sigma(u)") 
    ### ax.plot ( [llmin,llmax] , [1.,1.] , 'k',   marker = '*' , markersize = 0 ,  linewidth=.5 ,  label="valeur cible") 

    ax.legend(loc='best')
    plt.draw()  
    if jbavard >= 2: plt.savefig ('thn-graphique-Sigma.pdf', bbox_inches='tight',  pad_inches=0, transparent=True)

    ###  sortie du resultat dans un fichier 
    if jbavard >= 2: 
        fichier = open("thn-data-sigma", 'w')
        fmt = "{:20.13e} "*2 + "\n"
        fmt2 = "{:20.13e} "*7 + "\n"
        for k in range(NN+1) :
            fichier.write(fmt.format(uuu[k], Sigma[k]))
        fichier.close()
    
    return xmin
##################################################################################

##################################################################################
def graphe_VV (jbavard, NN, uuu, VV) :
##################################################################################
####  14 juin : ajout d une sortie sur fichier 
##################################################################################
    
    if jbavard >= 2: print ("sous-programme 'graphe_VV'")
    ymin = min(VV) ; ymax = max(VV) 
    ymax = ymax + .01*(ymax-ymin) ; ymin = ymin - .01*(ymax-ymin)
    xmin = -.01 ; xmax = 1.01 
    
    fig, ax = plt.subplots(figsize=(11,6))
    ax.set_xlim(xmin,xmax) ; ax.set_ylim(ymin,ymax)
    ax.set_title('fonction VV en fonction de u                 François Dubois                  31 mai 2021')
    
    ax.plot ( uuu, VV , 'b',   marker = '*' , markersize = 3 ,  linewidth=.3 ,  label="VV(u)") 

    ax.legend(loc='best')
    plt.draw()  
    if jbavard >= 2: plt.savefig ('thn-graphique-VV.pdf', bbox_inches='tight',  pad_inches=0, transparent=True)

    ###  sortie du resultat dans un fichier 
    if jbavard >= 2: 
        fichier = open("thn-data-vv", 'w')
        fmt = "{:20.13e} "*2 + "\n"
        for k in range(NN+1) :
            fichier.write(fmt.format(uuu[k], VV[k]))
        fichier.close()
   
    return xmin
##################################################################################

##################################################################################
def calcule_VV_de_uu_Sigma_P1_par_morceaux (jbavard, v00, v12, v11, zlambda, uu) : 
##################################################################################

    alpha = 1. - (v00/v12) ; beta = (v11/v12) - 1. ; xi = zlambda*v12

    VVV0 = 8*alpha*uu**3 - 12*alpha*uu**2 + 5*alpha*uu - beta*uu + 12*uu**2 - 12*uu
    VVV0 = VVV0*v12/24.
    VVV1 = 8*beta*uu**3 - 12*beta*uu**2 - alpha*uu + 5*beta*uu + 12*uu**2 + alpha - beta - 12*uu
    VVV1 = VVV1*v12/24.

    if (uu <= .5): VV = VVV0 
    else :         VV  = VVV1 
    return  VV
##################################################################################

##################################################################################
def calcule_VV_de_uu_Sigma_P2 (jbavard, v00, v12, v11, zlambda, uu) : 
##################################################################################
###  03 juin 
##################################################################################

    polP2 = uu**2*v00 - 2*uu**2*v12 + uu**2*v11 - 2*uu*v00 + 2*uu*v12 + v00 + 2*v12
    VVV = uu*(uu-1.)*polP2/6.
    
    return  VVV

##################################################################################
def genere_Sigma_VV_psi_P1_par_morceaux (jbavard, v00, v12, v11, zlambda, NN) : 
##################################################################################
###   31 mai 2021 : generation de quelques vecteurs discrets 
###          interpolation affine sur deux intervalles a partir de trois valeurs  
###          grille uniforme en uu, ok pour les graphiques...   
##################################################################################

    if (jbavard>=2) :
        print ("sous-programme 'genere_Sigma_VV_psi_P1_par_morceaux'")
        print ('generation de quelques vecteurs discrets')
        print ('interpolation affine sur deux intervalles a partir de trois valeurs')
    
    alpha = 1. - (v00/v12) ; beta = (v11/v12) - 1. ; xi = zlambda*v12
    if (jbavard>=2) :
        print ('alpha           =', alpha)
        print ('beta            =', beta)
        print ('zlambda         =', zlambda)
        print ('xi = lambda v12 =', xi)

    du = 1./NN ; err = 0.
    uuu = np.zeros(NN+1) ; psilambda = np.zeros(NN+1) ; Sigma = np.zeros(NN+1) ; VV = np.zeros(NN+1)
    psi00 = np.zeros(NN+1) ; psi11 = np.zeros(NN+1) ; psi = np.zeros(NN+1) 
    
    for j in range (NN+1):
        uu = j*du ;
        psi012 = -8*alpha*uu**3*xi + 12*alpha*uu**2*xi - 5*alpha*uu*xi + beta*uu*xi - 12*uu**2*xi + 12*uu*xi + 12*uu**2 -12 *uu
        psi0 = psi012/12.
        psi00[j] = psi0 
        sigma0 = v00*(1-2*uu) + 2*v12*uu
        VVV0 = 8*alpha*uu**3 - 12*alpha*uu**2 + 5*alpha*uu - beta*uu + 12*uu**2 - 12*uu
        VVV0 = VVV0*v12/24.
        psi112 = -8*beta*uu**3*xi + 12*beta*uu**2*xi + alpha*uu*xi - 5*beta*uu*xi -12*uu**2*xi - alpha*xi + beta*xi + 12*uu*xi + 12*uu**2 - 12*uu
        psi1 = psi112/12.    
        psi11[j] = psi1
        sigma1 = 2*v12*(1-uu)  + v11*(2*uu-1)
        VVV1 = 8*beta*uu**3 - 12*beta*uu**2 - alpha*uu + 5*beta*uu + 12*uu**2 + alpha - beta - 12*uu
        VVV1 = VVV1*v12/24.
        uuu[j] = uu
        if (uu <= .5):
            psilambda[j] = psi0
            Sigma[j]     = sigma0 
            VV[j]        = VVV0 
        if (uu > .5):
            psilambda[j] = psi1
            Sigma[j]     = sigma1
            VV[j]        = VVV1 
        psi [j] = double_psi (uu, v00, v12, v11, zlambda)
        err = max (err,abs(psi [j]-psilambda[j]))
    if (jbavard>=2) :
        print ('erreur dans le programme double_psi   ', err) 
        print ('====================================================================================')

    if (jbavard>=3) : print (uuu) ; print (Sigma)

    return  uuu, Sigma, VV, psilambda, psi00, psi11, psi
##################################################################################

##################################################################################
def double_psi  (uu, v00, v12, v11, zlambda) :
##################################################################################
###   29 mai ; cas d une fonction Sigma positive et affine par morceaux   
###          calcul pour uu donne de la fonction psi dans P3 sur deux intervalles  
##################################################################################
##################################################################################

    alpha = 1. - (v00/v12) ; beta = (v11/v12) - 1. ; xi = zlambda*v12
    if (uu<=.5) :
        psi012 = -8*alpha*uu**3*xi + 12*alpha*uu**2*xi - 5*alpha*uu*xi + beta*uu*xi - 12*uu**2*xi + 12*uu*xi + 12*uu**2 -12 *uu
        psi    = psi012/12.
    if (uu>.5) :
        psi112 = -8*beta*uu**3*xi + 12*beta*uu**2*xi + alpha*uu*xi - 5*beta*uu*xi -12*uu**2*xi - alpha*xi + beta*xi + 12*uu*xi + 12*uu**2 - 12*uu
        psi    = psi112/12.

    return psi
##################################################################################


##################################################################################
def psi_P4  (uu, v00, v12, v11, zlambda) :
##################################################################################
###   03 juin : fonction psi pour Sigma de degre 2
##################################################################################
##################################################################################

    polP2 = uu**2*v00 - 2*uu**2*v12 + uu**2*v11 - 2*uu*v00 + 2*uu*v12 + v00 + 2*v12
    VVV = uu*(uu-1.)*polP2/6. 
    psi = uu*(uu-1.) - 2.*zlambda*VVV
    
    return psi
##################################################################################


##################################################################################
def trapezes_psi_pour_Sigma_P1_par_morceaux (jbavard,v00, v12, v11, zlambda,NN) :
##################################################################################
###   29 mai ; cas d une fonction Sigma positive et affine par morceaux   
###          calcul pour de l integrale par une methode des trapezes  
###          on doit dispose d un programme qui calcule les valeurs de la fonction    
##################################################################################

    dtheta = pi/(2.*NN)
    fff =  np.zeros(NN+1)

    for j in range(1,NN) :
        tt = j*dtheta
        sin2tt = sin(2*tt)
        sintt2 = sin(tt)**2
        psi = double_psi (sintt2 , v00, v12, v11, zlambda) 
        fff[j] = sin2tt/sqrt(psi)

    int = 0.
    ## int = int + .5*fff[0] + .5*fff[NN]
    
    for j in range(1,NN) :
        int = int + fff[j]
    int = dtheta*int

    NN2 = floor(NN/2)
    if (jbavard>=2) : print ("NN2") ; print (NN2)
    
    int0 = 0. 
    for j in range(1,NN2) :
        int0 = int0 + fff[j]
    int0 = dtheta*int0
    if (jbavard>=2) :
        print ("int0") ; print (int0)
        print ("int1") ; print (int-int0)
    
    return int
##################################################################################

##################################################################################
def trapezes_psi_pour_Sigma_generale (jbavard,interpol,v00, v12, v11, zlambda,NN) :
##################################################################################
###   29 mai ; cas d une fonction Sigma positive et affine par morceaux   
###          calcul pour de l integrale par une methode des trapezes  
###          on doit dispose d un programme qui calcule les valeurs de la fonction 
###   03 juin : fonction psi pour Sigma de degre 2   
##################################################################################

    if jbavard >= 2 : print ("sous-programme 'trapezes_psi_pour_Sigma_generale'")
    dtheta = pi/(2.*NN)
    fff =  np.zeros(NN+1)

    for j in range(1,NN) :
        tt = j*dtheta
        sin2tt = sin(2*tt)
        sintt2 = sin(tt)**2
        if (interpol==2) : psi = psi_P4 (sintt2 , v00, v12, v11, zlambda) 
        if (interpol==3) : psi = double_psi (sintt2 , v00, v12, v11, zlambda) 
        fff[j] = sin2tt/sqrt(psi)

    int = 0.
    
    for j in range(1,NN) :
        int = int + fff[j]
    int = dtheta*int

    if (interpol==3) :
         NN2 = floor(NN/2)
         if (jbavard>=2) : print ("NN2") ; print (NN2)
    
         int0 = 0. 
         for j in range(1,NN2) :
             int0 = int0 + fff[j]
         int0 = dtheta*int0
         if (jbavard>=2) :
             print ("int0") ; print (int0)
             print ("int1") ; print (int-int0)
    
    return int
##################################################################################



##################################################################################
def int_exacte_03juin (jbavard, v00, v12, v11, zlambda) :
##################################################################################
###   03 juin : cas ou Sigma est P2, donc psi est P4    
###             attention, psi doit etre vraiment P4 !    
##################################################################################

    mu = .5*(v00+v11) ; alpha = (v11/mu)-1. ; dd = (v12/mu)-1.
    coh00 = v00 - mu*(1-alpha) ; coh12 = v12 - mu*(1+dd) ; coh11 = v11 - mu*(1+alpha)
    xi = zlambda*mu 
    aa  = 2.*xi*dd/3.  
    gamma  = 1. - (abs(alpha)/3.) + 2.*dd/3. 
    somme  = 1 + (alpha/dd)   
    prodt  = (1 - xi + (alpha*xi/3.) - (2.*dd*xi)/3.)/aa  

    if (jbavard>=2) :
        print ('====================================================================================')
        print ("sous-programme 'int_exacte_03juin'")
        print ('   cas ou Sigma est un polynome P2, donc psi est P4')
        print ('   attention, psi doit etre vraiment P4 !')        
        print ("zlambda") ; print (zlambda)
        print ("v00") ; print (v00)
        print ("v12") ; print (v12)
        print ("v11") ; print (v11)
        print ("mu") ; print (mu)
        print ("alpha") ; print (alpha)
        print ("dd") ; print (dd)
        print ("coh00     coh12     coh11") ; print (coh00,coh12,coh11)
        print ("xi") ; print (xi)
        print ("aa") ; print (aa)
        print ("gamma qui doit etre positif ") ; print (gamma)
        print ("somme   somme pp + gg") ; print (somme)
        print ("prodt   produit pp*gg") ; print (prodt)

    if (prodt<0) : 
        if (jbavard>=2) :  print ('cas d un produit negatif : pp < 0 < 1 < gg')
        intex = int_exacte_17mai (jbavard, v00, v12, v11, zlambda)
        if (jbavard>=2) :  print ("intex   integrale exacte a zlambda donne") ; print (intex)

    if (prodt>=0) :
        det = 4.*xi*((5.*dd*dd + alpha*alpha + 6.*dd)*xi - 6.*dd  )/(9.*aa*aa)
        det1 = somme*somme - 4.*prodt
        erreur =abs(det-det1)
        if (jbavard>=2) : print ("det     determinant de l equation du second degre") ; print (det) 
        if (jbavard>=2) : print ("erreur  avec un second calcul du determinant") ; print (erreur)   
        if (det>=0) : 
            pp = .5*(somme-sqrt(det)) ; gg = .5*(somme+sqrt(det))
            if (jbavard>=2) : print ("pp   petite racine") ; print (pp)
            if (jbavard>=2) : print ("gg   grande racine") ; print (gg)
            if ((pp<0)&(gg>1)) : 
                if (jbavard>=2) : print ("on a     pp < 0 < 1 gg")
                intex = int_exacte_17mai (jbavard, v00, v12, v11, zlambda)/sqrt(aa) 
            if ((pp<0)&(gg<0)) :
                if (jbavard>=2) : print ("on a     pp < 0 et  gg < 0")
                ### jbavard = 1
                intex = int_exacte_v4 (jbavard,pp,gg)/sqrt(-aa)
                if (jbavard>=2) : print ("intex   integrale exacte a zlambda donne") ; print (intex)
                intex27 = int_exacte_27mai (jbavard, v00, v12, v11, zlambda)
                if (jbavard>=2) : print ("intex27    edition 27 mai") ; print (intex27)            
                ###  intapprochee =  trapezes_v3 (pp,gg,NN) / sqrt(abs(-aa))  
                ###  print ("intapprochee") ; print (intapprochee)
            if ((pp>1.)&(gg>1.)) :
                if (jbavard>=2) : print ("on a     pp > 1 et  gg > 1")
                ### jbavard = 1
                intex = int_exacte_v3 (jbavard,pp,gg)/sqrt(-aa)
                if (jbavard>=2) : print ("intex   integrale exacte a zlambda donne") ; print (intex)
                intex27 = int_exacte_27mai (jbavard, v00, v12, v11, zlambda)            
                if (jbavard>=2) : print ("intex27    edition 27 mai") ; print (intex27)            
                ###  intapprochee =  trapezes_v3 (pp,gg,NN) / sqrt(abs(-aa))  
                ###  print ("intapprochee") ; print (intapprochee)
            
        if (det<0) : 
            if (jbavard>=2) : print ("on a deux racines complexes")
            imaginaire = .5*sqrt(-det)
            if (jbavard>=2) : print ("imaginaire") ; print (imaginaire)
            ### jbavard = 1
            intex = int_exacte_complexes (jbavard,somme,imaginaire)/sqrt(abs(aa)) 
            if (jbavard>=2) : print ("intex   integrale exacte a zlambda donne") ; print (intex)
            intex26 = int_exacte_26mai (jbavard, v00, v12, v11, zlambda)
            if (jbavard>=2) : print ("intex26    edition 26 mai") ; print (intex26)
            
    if (jbavard>=2) :
        print ('fin du programme int_exacte_03juin')
        print ('====================================================================================')

    return intex 
##################################################################################

##################################################################################
def genere_Sigma_VV_psi_P2 (jbavard, v00, v12, v11, zlambda, NN) : 
##################################################################################
###  3 juin 2021
##################################################################################

    if (jbavard>=2) :
        print ('=======================================================')
        print ('genere_Sigma_VV_psi_P2')
        print ('la fonction Sigma est un interpole P2')

    du = 1./NN ; err = 0.
    uuu = np.zeros(NN+1) ; psi = np.zeros(NN+1) ; Sigma = np.zeros(NN+1) ; VV = np.zeros(NN+1) ; psitj = np.zeros(NN+1)
    
    for j in range (NN+1):
        uu = j*du 
        sigma = v00*(1-uu)*(1.-2*uu) + 4*v12*uu*(1.-uu) + v11*uu*(2*uu-1.) 
        uuu[j] = uu
        Sigma[j] = sigma 
        douzepsiv2 = 4*(uu**2)*v00*zlambda -8*(uu**2)*v12*zlambda + 4*(uu**2)*v11*zlambda -8*uu*v00*zlambda + 8*uu*v12*zlambda \
            - uu**2 + 4*v00*zlambda + 8*v12*zlambda + uu + 1
        douzepsiv2 = uu*(1.-uu)*douzepsiv2
        douzepsi = -4*uu**4*v00*zlambda + 8*uu**4*v12*zlambda -4*uu**4*v11*zlambda + 12*uu**3*v00*zlambda -16*uu**3*v12*zlambda
        douzepsi = douzepsi + 4*uu**3*v11*zlambda + uu**4 -12*uu**2*v00*zlambda -2*uu**3 + 4*uu*v00*zlambda + 8*uu*v12*zlambda + uu
        psi[j]  = douzepsiv2/12.
        ###  psitj[j]  = douzepsi/12.
        polP2 = uu**2*v00 - 2*uu**2*v12 + uu**2*v11 - 2*uu*v00 + 2*uu*v12 + v00 + 2*v12
        VVV = uu*(uu-1.)*polP2/6. 
        VV[j] = VVV
        psi_3juin = uu*(uu-1.) - 2.*zlambda*VVV
        psi_3juin = ((-1)/3)*uu**4*v00*zlambda + 2/3*uu**4*v12*zlambda + ((-1)/3)*uu**4*v11*zlambda + uu**3*v00*zlambda \
            + ((-4)/3)*uu**3*v12*zlambda + 1/3*uu**3*v11*zlambda - uu**2*v00*zlambda + 1/3*uu*v00*zlambda + 2/3*uu*v12*zlambda + uu**2 - uu      
        psitj[j]  = psi_3juin
        err = err + abs(psi[j]-psitj[j])

    if (jbavard>=3) : print ('err') ; print(err)
    if (err>.0001) :
        if (jbavard>=3) : print ('attention a la fonction psi calculee dans le module test06') 

    return  uuu, Sigma, VV, psi, psitj  

##################################################################################

##################################################################################
def Sigma_historic_p1 (uu,v00, v12, v11) :
##################################################################################
##  15 mai 2021 donnee issues du job sage "historique-02"
##  -aa + 1/6*v00 + ((-1)/6)*v11
##  -bb + ((-17)/96)*v00 + ((-5)/16)*v12 + ((-1)/96)*v11
##################################################################################
    
    aa = v00/6. - v11/6.  
    bb = -(17/96.)*v00 - 5*v12/16. - v11/96. 
    vv = uu*(1-uu)*(aa*uu+bb)
    sigma = -6*aa*uu + 2*aa - 2*bb

    return sigma
##################################################################################

##################################################################################
def Sigma_historic_p2 (uu,v00, v12, v11) :
##################################################################################
##  attention. la premiere version du 14 mai etait bugguee
##################################################################################

    aa = v00/6. - v11/6.  
    bb = -2.*v00/15. - 2*v12/5. + v11/30. 
    vv = uu*(1-uu)*(aa*uu+bb) 
    sigma = -6*aa*uu + 2*aa - 2*bb
    
    return sigma
##################################################################################


###########################################################################################
def calcule_ordre_de_convergence  (jbavard, interpol, v00, v12, v11, zlambda, NN, lambda_exact, nbnewton) :
###########################################################################################
### fd 4 juin 2021 
### 15 juin : ajout d un parametre de sortie  
###########################################################################################
    
    ll = zlambda
    
    if (jbavard>=2) :
        print ('===================================================================================')
        print ("sous-programme 'calcule_ordre_de_convergence'")
        print ('convergence de lambda, calcul approche de l integrale pour deux valeurs de NN')
        print ('pour chaque valeur de NN, on itere un Newton pour faire converger lambda')
        print ("ll : valeur unitiale de lambda au debut de l algorithme de Newton")  ; print (ll)

        
    intappro,dxi,err = calcul_numerique_integrale (jbavard, interpol, v00, v12, v11, zlambda, NN)    
    if (jbavard>=3) :
        print ("integrale approchee  intappro")  ; print (intappro)
        print ("dxi")  ; print (dxi)
        print ("err")  ; print (err)

        
    for knewton in range(nbnewton) :
        ddll = (1.-intappro)/dxi 
        ll = ll + ddll
        intappro,dxi,err = calcul_numerique_integrale (jbavard, interpol, v00, v12, v11, ll, NN)     
        if (jbavard>=3) : print (ll,intappro)
    
    zlambdaNN = ll ; errNN = err ; intapproNN = intappro ; errlambdaNN = abs (zlambdaNN - lambda_exact)
    if (jbavard>=2) :
        print ("erreur sur le calcul de la longueur totale          errNN")  ; print (errNN)
        print ("valeur propre pour NN mailles                   zlambdaNN")  ; print (zlambdaNN)
        print ("ecart par rapport a la valeur propre exacte   errlambdaNN")  ; print (errlambdaNN)


    NN2 = 2*NN ; ll = zlambdaNN
    for knewton in range(nbnewton) :
        intappro,dxi,err = calcul_numerique_integrale (jbavard, interpol, v00, v12, v11, ll, NN2)  
        ddll = (1.-intappro)/dxi 
        ll = ll + ddll   
        if (jbavard>=3) : print (ll,intappro)
    zlambdaNN2 = ll ; errNN2 = err ; intapproNN2 = intappro ; errlambdaNN2 = abs (zlambdaNN2 - lambda_exact)
    if (jbavard>=2) :
        print ("erreur sur le calcul de la longueur totale          errNN2")  ; print (errNN2)
        print ("valeur propre pour NN mailles                   zlambdaNN2")  ; print (zlambdaNN2)
        print ("ecart par rapport a la valeur propre exacte   errlambdaNN2")  ; print (errlambdaNN2)

    ordrecv = log(errlambdaNN/errlambdaNN2)/log(2.)
    if (jbavard>=2) : print ('ordre de convergence    ordrecv') ; print (ordrecv)

    return zlambdaNN, ordrecv
###########################################################################################

##################################################################################
def calcul_numerique_integrale (jbavard, interpol, v00, v12, v11, zlambda, NN) :
##################################################################################
###   31 mai 2021  reprise du programme "calculintegrale" de fin avril 2021 
###                ok pour Sigma obtenu par un raccord d integrales   
###                il faudra rajouter un flyer pour preciser comment on calcule
###                la valeur Vu afin de traiter les autres cas   
###   03 juin 2021 : ajout du parametre 'interpol' sur le choix de l interpolation    
###   15 juin 2021 : ajout d une sortie sur fichier       
###   17 juin 2021 : correction de bug pour la sortie sur fichier    
##################################################################################

    uuu = np.zeros(NN+1) ; psi = np.zeros(NN+1) ; Vsr = np.zeros(NN+1) ; xxx = np.zeros(NN+1) 

    hh = 1./NN
    if (jbavard >= 3) : print ('hh') ; print (hh)

    for j in range(NN+1) :
        xi       = j*hh
        uu       = (sin(.5*pi*xi))**2
        if (interpol==2) : Vu = calcule_VV_de_uu_Sigma_P2 (jbavard, v00, v12, v11, zlambda, uu)
        if (interpol==3) : Vu = calcule_VV_de_uu_Sigma_P1_par_morceaux (jbavard, v00, v12, v11, zlambda, uu)
        uuu[j]   = uu
        psi[j]   = uu*(uu-1.) - 2.*zlambda*Vu 
        if (j>=1)&(j<NN) :  Vsr[j] = Vu/sqrt(psi[j])
    psi[0] = 0. ; psi[NN] = 0.  ### pour pallier a certaines erreurs d arrondis... 
        
    if (jbavard >= 4) :
        print ('uuu') ; print (uuu) ;
        print ('psi') ; print (psi) ;
        print ('Vsr') ; print(Vsr)

    int = 0.
    dxi = 0.
    for j in range(NN) :
        dI = (uuu[j+1]-uuu[j])/(.5*(sqrt(psi[j])+sqrt(psi[j+1])))
        xxx[j+1] = xxx[j] + dI
        dhsurdlambda = dI*(Vsr[j] + Vsr[j+1])/(sqrt(psi[j])+sqrt(psi[j+1]))
        int = int + dI
        dxi = dxi + dhsurdlambda

    if (jbavard >= 3) : print ('int') ; print (int)
    if (jbavard >= 3) : print ('dxi') ; print (dxi)
    err = 1.-int
    if (jbavard >= 3) : print ('erreur pour l integrale   err') ; print (err)

    ###  sortie du resultat dans un fichier
    if jbavard >= 2 : 
        fichier = open("thn-data-xxx-uuu-phi", 'w')
        fmt = "{:20.13e} "*3 + "\n"
        for k in range(NN+1) :
        ### phi = sqrt{psi[k]}
            fichier.write(fmt.format(xxx[k],uuu[k], sqrt(psi[k])))
        fichier.close()

    
    return int,dxi,err
##################################################################################

##########################################
def cercle (xc,yc,R) : 
    n = 100  ## 4  ### 100 
    dth = 2*pi/n
    x=np.zeros(n+1) ; y=np.zeros(n+1)
    for j in range(0,n+1) :
         x[j] = xc + R*cos(j*dth)
         y[j] = yc + R*sin(j*dth) 
    return x,y 
##########################################
